//LabPlot : Dialog.h

#ifndef DIALOG_H
#define DIALOG_H

#include <kdialog.h>
#include <qvbox.h>
#include <kpushbutton.h>
#include <qgroupbox.h>
#include <qcheckbox.h>
#include <qtabwidget.h>
#include <qvalidator.h>
#include <klineedit.h>
#include <klistbox.h>
#include <kcolorbutton.h>
#include <kcombobox.h>
#include "Worksheet.h"

class Dialog: public KDialog
{
	Q_OBJECT
public:
	Dialog(MainWin *mw, const char *name);
	QVBox* surfaceStyle(QTabWidget *tw, bool fresh);
	QVBox* simpleStyle(QTabWidget *tw, Graph *graph, Style *style, Symbol *symbol);
	void saveSimpleStyle();
	void saveSurfaceStyle();
protected:
	void resizeEvent(QResizeEvent *e);
	QVBox* annotateValuesTab(QTabWidget *tw, Graph *graph);
       	void importWidget(QVBox *vb,QString filename);
	double getBinaryValue(QDataStream *d, int type);
	QGroupBox *vbox, *gbox;
	MainWin *mw;
	Worksheet *p;
	Spreadsheet *s;
	KPushButton *ok, *apply, *cancel;
	KLineEdit *filele;						// used from various dialogs
	KComboBox *cb2, *pencb, *brushcb, *sbrushcb;			// simple
	KComboBox *symbolcb, *symbolfillcb;					// simple
	KColorButton *color, *fcolor, *scolor, *sfcolor;			// simple
	QCheckBox *filled;									// simple
	KLineEdit *boxwidthle, *ssize, *widthle;							// simple
	QCheckBox *autobox, *ccb, *dcb, *coloredcb, *meshcb, *relativecb;	// surface
	KLineEdit *numberle, *thresholdle;						// surface
	KComboBox *pcb, *dbrushcb;							// surface
	KColorButton *contourcolor;							// surface
	KComboBox *typecb, *positioncb;						// annotatetab
	KLineEdit *distancele;								// annotatetab
	QCheckBox *simplifycb, *emptycb;								// importWidget
	QLabel *seplabel, *commlabel, *startlabel, *endlabel;		// importWidget
	KLineEdit *startle, *endle;							// importWidget
	KComboBox *filtercb, *sccb, *commcb;					// importWidget
	QLabel *varlabel, *binarytypelabel;					// importWidget : binary
	KLineEdit *varle;
	KComboBox *binarytypecb;
	KComboBox *sheetcb;					// for destination selection (list dialogs+function/data dialog)
protected slots:
	void selectFile();
	void fileInfo();
	void updateFilter(int item);
	QStringList splitLine(QString line,QString sep, bool empty);
private:
	void fillBrushBox(KComboBox *cb,SType t, QColor c,FType f, QColor s);
	void fillSymbolBox(QColor c, FType f, QColor s, int b);
	void fillSymbolFillBox(SType t, QColor c, QColor s, int b);
private slots:
	void styleChanged();
	void symbolChanged();
};

#endif //DIALOG_H
