#include <kdebug.h>
#include "VectorDataSource.h"

VectorDataSource::VectorDataSource(vector<double>* passedTime, vector<double>* passedData)
{
    time = passedTime;
    data = passedData;
    establishRowColNumbers();
    connectedToTable = FALSE;  
}

QString VectorDataSource::cell(int row, int col) const
{
    if (connectedToTable) {
        if (col == 0)
            return QString::number((*time)[row]);
        return QString::number((*data)[row]);
    }
    else 
        return QString(" ");
}

void VectorDataSource::setCell(int row, int col, const QString &text) {
	int size = time->size();
	if(row >= size) {
		//kdDebug()<<"setCell() : "<<row<<' '<<col<<endl;
		nRows=size+100;
		time->resize(nRows);
		data->resize(nRows);
	}
    if (connectedToTable) {
    	if (col == 0)
        	(*time)[row] = text.toDouble();
    	(*data)[row] = text.toDouble();
    	//emit dataChanged();
    }
}

void VectorDataSource::establishRowColNumbers()
{
	time->resize(100);
	data->resize(100);
    nRows = 100;//(*time).size();
    nCols = 2; 
}

void VectorDataSource::connectToTable(bool conn)
{
    connectedToTable = conn;
}
