#ifndef VECTORDATASOURCE_H
#define VECTORDATASOURCE_H

#include <qobject.h>
#include <qstring.h>
#include <qfile.h>
#include <vector>

#include "DataSource.h"

using namespace std;

class VectorDataSource : public DataSource
{
    Q_OBJECT
public:
    VectorDataSource(vector<double>* passedTime=0, vector<double>* passedData=0);
    
    QString cell(int row, int col) const;
    void setCell(int row, int col, const QString &text);

    int numRows() const {return nRows;}
    int numCols() const {return nCols;}
    void establishRowColNumbers();
    void connectToTable(bool conn);

private:
    int nRows;
    int nCols;
    vector<double>* time;
    vector<double>* data;
    bool connectedToTable;
};

#endif

